<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Northern.tech Proxy</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bulma/0.7.4/css/bulma.min.css">
    <script>
      function set_input(input, method, path) {
        input.querySelector("#select_method").value = method;
        input.querySelector("#input_path").value = path;
      }
      function add_input() {
        var input_container = document.getElementById("input-container");
        var new_input = input_container.lastElementChild.cloneNode(true);
        var count = parseInt(new_input.id.replace("input-", ""));
        count += 1;
        new_input.id = "input-" + count;
        set_input(new_input, "GET", "");

        input_container.appendChild(new_input);
      }
      function remove_by_id(id) {
        var element = document.getElementById(id);
        var parent = element.parentElement;
        parent.removeChild(element);
      }
      function only_child(element) {
        var parent = element.parentElement;
        var children = parent.children;
        return children.length == 1;
      }
      function remove_input(button_node) {
        var field = button_node.parentElement.parentElement;
        if (!only_child(field)) {
          remove_by_id(field.id);
        }
      }
      function post_json(data, path, callback) {
        // construct an HTTP request
        var xhr = new XMLHttpRequest();
        xhr.open("POST", path, true);
        xhr.setRequestHeader('Content-Type', 'application/json; charset=UTF-8');

        xhr.onloadend = callback
        // send the collected data as JSON
        xhr.send(JSON.stringify(data));
      }
      function get_json(path, callback) {
        // construct an HTTP request
        var xhr = new XMLHttpRequest();
        xhr.open("GET", path, true);

        xhr.onloadend = callback
        // send the collected data as JSON
        xhr.send();
      }
      function save_callback(evt) {
        console.log(evt);
      }
      function save() {
        var rows = [];
        var inputs = document.getElementById("input-container").children;
        for (var i = 0; i < inputs.length; ++i) {
          var input = inputs[i];
          var method = input.querySelector("#select_method");
          var path = input.querySelector("#input_path");
          var element = {
            "method": method.value,
            "path": path.value
          };
          rows.push(element);
        }
        var data = {};
        data["config"] = rows;
        post_json(data, "/state", save_callback)
      }

      function reload_callback(evt) {
        data = JSON.parse(evt.target.response);
        console.log(data);
        config = data.config
        for (var i = 1; i < config.length; ++i) {
          if (i > 0) {
            add_input();
          }
        }
        var inputs = document.getElementById("input-container").children;
        for (var i = 0; i < inputs.length; ++i) {
          var row = config[i];
          var input = inputs[i];
          set_input(input, row.method, row.path);
        }
      }
      function reload() {
        get_json("/state", reload_callback);
      }
    </script>
  </head>
  <body>
    <section class="section">
      <div class="container">
        <h1 class="title">
          Northern.tech proxy
        </h1>
        <a class="button is-link" href="/state">
          Check state
        </a>
        <a class="button is-link" href="http://127.0.0.1:3001">
          Open Proxy
        </a>
        <a class="button is-link" href="http://127.0.0.1:8000">
          Open Target
        </a>
      </div>
    </section>
    <section class="section">
      <div class="container" id="input-container">
        <div class="field has-addons" id="input-0">
          <p class="control">
            <span class="select">
              <select id="select_method">
                <option>GET</option>
                <option>POST</option>
              </select>
            </span>
          </p>
          <p class="control is-expanded">
            <input id="input_path" class="input" type="text" placeholder="PATH">
          </p>
          <p class="control">
            <a class="button is-primary" onclick="add_input();">
              <b>+</b>
            </a>
          </p>
          <p class="control">
            <a class="button is-danger" onclick="remove_input(this);">
              <b>-</b>
            </a>
          </p>
        </div>
      </div>
    </section>
    <section class="section">
      <div class="container">
        <div class="field is-grouped">
          <div class="control">
            <button class="button is-primary" onclick="save();">Save</button>
          </div>
        </div>
      </div>
    </section>
  </body>
  <script>
    reload();
  </script>
</html>